## hashcat 4.2.1

=== src/Makefile ===
##
## Author......: See docs/credits.txt
## License.....: MIT
##

SHARED                  := 0
DEBUG                   := 0
PRODUCTION              := 1
PRODUCTION_VERSION      := v4.2.1

##
## Detect Operating System
##

UNAME                   := $(shell uname -s)

# we need to strip the windows version number to be able to build hashcat on cygwin hosts
UNAME                   := $(patsubst CYGWIN_NT-%,CYGWIN,$(UNAME))

# same for msys
UNAME                   := $(patsubst MSYS_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW32_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW64_NT-%,MSYS2,$(UNAME))

ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin CYGWIN MSYS2))
$(error "! Your Operating System ($(UNAME)) is not supported by this Makefile")
endif

ifeq ($(DEBUG),1)
$(warning "## Detected Operating System : $(UNAME)")
endif

##
## Makefile flags
##

MAKEFLAGS               += -l -j -rR --no-print-directory

ifneq ($(findstring clean,$(MAKECMDGOALS)),)
MAKEFLAGS               += -j 1
endif

##
## Native compiler paths
##

CC                      := gcc
FIND                    := find
INSTALL                 := install
RM                      := rm
SED                     := sed
SED_IN_PLACE            := -i

ifeq ($(UNAME),Darwin)
CC                      := clang
# the sed -i option of macOS requires a parameter for the backup file (we just use "")
SED                     := /usr/bin/sed
SED_IN_PLACE            := -i ""
PROD_VERS               := $(shell sw_vers -productVersion | cut -d. -f2)
endif

ifeq ($(UNAME),FreeBSD)
CC                      := cc
SED                     := gsed
endif

##
## Version
##

ifeq ($(PRODUCTION),1)
VERSION_TAG             := $(PRODUCTION_VERSION)
else
VERSION_TAG             := $(shell git describe --tags --dirty=+ || echo $(PRODUCTION_VERSION))
endif # PRODUCTION

VERSION_PURE            := $(shell echo "$(VERSION_TAG)" | $(SED) 's/.*v\([\.0-9]*\).*/\1/')

##
## Installation paths (Linux only)
##

DESTDIR                 ?=
PREFIX                  ?= /usr/local

INSTALL_FOLDER          ?= $(PREFIX)/bin
SHARED_ROOT_FOLDER      ?= $(PREFIX)/share
SHARED_FOLDER           ?= $(SHARED_ROOT_FOLDER)/hashcat
DOCUMENT_FOLDER         ?= $(SHARED_ROOT_FOLDER)/doc/hashcat
LIBRARY_FOLDER          ?= $(PREFIX)/lib
LIBRARY_DEV_ROOT_FOLDER ?= $(PREFIX)/include
LIBRARY_DEV_FOLDER      ?= $(LIBRARY_DEV_ROOT_FOLDER)/hashcat

##
## Filenames for library and frontend
##

HASHCAT_FRONTEND        := hashcat
HASHCAT_LIBRARY         := libhashcat.so.$(VERSION_PURE)

ifeq ($(UNAME),Darwin)
HASHCAT_LIBRARY         := libhashcat.$(VERSION_PURE).dylib
endif # Darwin

ifeq ($(UNAME),CYGWIN)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # MSYS2

##
## Dependencies
## You may ignore them if you're compiling only a native binary and
## You have your own headers somewhere, for example: apt-get install opencl-headers
##

OPENCL_HEADERS_KHRONOS  := deps/OpenCL-Headers

##
## Cross compiler paths
##

CC_LINUX_32             := gcc
CC_LINUX_64             := gcc

CC_WIN_32               := i686-w64-mingw32-gcc
CC_WIN_64               := x86_64-w64-mingw32-gcc

## To compile win-iconv with mingw clone from here: https://github.com/win-iconv/win-iconv
##
## Then patch the makefile with the patches from tools/win-iconv-*.diff and run make install
##

WIN_ICONV_32            := /opt/win-iconv-32
WIN_ICONV_64            := /opt/win-iconv-64

##
## Misc stuff
##

COMPTIME                := $(shell date +%s)
SYSTEM_LZMA_SDK         := 0

LZMA_SDK_INCLUDE        := $(LIBRARY_DEV_ROOT_FOLDER)/lzma-sdk/C

##
## General compiler and linker options
##

CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/

ifeq ($(PRODUCTION),0)
CFLAGS                  += -W
CFLAGS                  += -Wall
CFLAGS                  += -Wextra
CFLAGS                  += -Wfloat-equal
CFLAGS                  += -Wundef
CFLAGS                  += -Wshadow
CFLAGS                  += -Wmissing-declarations
CFLAGS                  += -Wmissing-prototypes
CFLAGS                  += -Wpointer-arith
CFLAGS                  += -Wstrict-prototypes
CFLAGS                  += -Waggregate-return
CFLAGS                  += -Wswitch-enum
CFLAGS                  += -Winit-self
CFLAGS                  += -Werror-implicit-function-declaration
CFLAGS                  += -Wformat
CFLAGS                  += -ftrapv
CFLAGS                  += -Wwrite-strings
endif

# default Linux and freebsd thread stack size is 2MB
# default Windows thread stack size is 1MB
# default macOS thread stack size is 512kB
# unfortunately, this option isn't supported by older GCC and clang versions

#CFLAGS                  += -Wstack-usage=524288

ifeq ($(SYSTEM_LZMA_SDK),0)
CFLAGS                  += -Ideps/lzma_sdk/
else
CFLAGS                  += $(LZMA_SDK_INCLUDE)
LDFLAGS                 += -llzmasdk
endif

LFLAGS                  := $(LDFLAGS)

ifeq ($(DEBUG),0)
CFLAGS                  += -O2
ifneq ($(UNAME),Darwin)
LFLAGS                  += -s
endif
else
ifeq ($(DEBUG),1)
CFLAGS                  += -DDEBUG -Og -ggdb
else
ifeq ($(DEBUG),2)
CFLAGS                  += -DDEBUG -Og -ggdb
CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
endif
endif
endif

##
## Native compilation target
##

ifeq ($(UNAME),Linux)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -ldl
LFLAGS_NATIVE           += -lrt
LFLAGS_NATIVE           += -lm
endif # Linux

ifeq ($(UNAME),FreeBSD)
ifndef PORTNAME
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -I$(OPENCL_HEADERS_KHRONOS)/
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -lm
endif
endif # FreeBSD

ifeq ($(UNAME),Darwin)
export MACOSX_DEPLOYMENT_TARGET=10.9
CFLAGS_NATIVE           := $(CFLAGS)

ifeq ($(shell test $(PROD_VERS) -le 11; echo $$?), 0)
CFLAGS_NATIVE           += -DMISSING_CLOCK_GETTIME
endif

LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -framework OpenCL
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -liconv
endif # Darwin

ifeq ($(UNAME),CYGWIN)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
endif # MSYS2

##
## Cross compilation targets
##

CFLAGS_CROSS_LINUX32    := $(CFLAGS)
CFLAGS_CROSS_LINUX32    += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_CROSS_LINUX32    += -m32
CFLAGS_CROSS_LINUX32    += -DWITH_HWMON
CFLAGS_CROSS_LINUX64    := $(CFLAGS)
CFLAGS_CROSS_LINUX64    += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_CROSS_LINUX64    += -m64
CFLAGS_CROSS_LINUX64    += -DWITH_HWMON
CFLAGS_CROSS_WIN32      := $(CFLAGS)
CFLAGS_CROSS_WIN32      += -D__MINGW_USE_VC2005_COMPAT #hack to get 64-bit time_t
CFLAGS_CROSS_WIN32      += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_CROSS_WIN32      += -I$(WIN_ICONV_32)/include/
CFLAGS_CROSS_WIN32      += -m32
CFLAGS_CROSS_WIN32      += -DWITH_HWMON
CFLAGS_CROSS_WIN64      := $(CFLAGS)
CFLAGS_CROSS_WIN64      += -I$(OPENCL_HEADERS_KHRONOS)/
CFLAGS_CROSS_WIN64      += -I$(WIN_ICONV_64)/include/
CFLAGS_CROSS_WIN64      += -m64
CFLAGS_CROSS_WIN64      += -DWITH_HWMON

LFLAGS_CROSS_LINUX32    := $(LFLAGS)
LFLAGS_CROSS_LINUX32    += -lpthread
LFLAGS_CROSS_LINUX32    += -ldl
LFLAGS_CROSS_LINUX32    += -lm
LFLAGS_CROSS_LINUX64    := $(LFLAGS)
LFLAGS_CROSS_LINUX64    += -lpthread
LFLAGS_CROSS_LINUX64    += -ldl
LFLAGS_CROSS_LINUX64    += -lm
LFLAGS_CROSS_WIN32      := $(LFLAGS)
LFLAGS_CROSS_WIN32      += -Wl,--dynamicbase -Wl,--nxcompat
LFLAGS_CROSS_WIN32      += -lpsapi
LFLAGS_CROSS_WIN64      := $(LFLAGS)
LFLAGS_CROSS_WIN64      += -Wl,--dynamicbase -Wl,--nxcompat
LFLAGS_CROSS_WIN64      += -lpsapi

CFLAGS_REMOVE_LZMA        := -Wmissing-declarations -Wmissing-prototypes -Wstrict-prototypes -Wundef

CFLAGS_NATIVE_LZMA        := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_NATIVE))
CFLAGS_CROSS_LINUX32_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX32))
CFLAGS_CROSS_LINUX64_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX64))
CFLAGS_CROSS_WIN32_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN32))
CFLAGS_CROSS_WIN64_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN64))

##
## Objects
##

OBJS_ALL                := affinity autotune benchmark bitmap bitops combinator common convert cpt cpu_aes cpu_crc32 cpu_des cpu_md4 cpu_md5 cpu_sha1 cpu_sha256 debugfile dictstat dispatch dynloader event ext_ADL ext_nvapi ext_nvml ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface locking logfile loopback memory monitor mpsp opencl outfile_check outfile pidfile potfile restore rp rp_cpu rp_kernel_on_cpu rp_kernel_on_cpu_optimized selftest shared status stdout straight terminal thread timer tuningdb usage user_options wordlist

NATIVE_STATIC_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.STATIC.o)
NATIVE_SHARED_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.SHARED.o)

LINUX_32_OBJS           := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).LINUX.32.o)
LINUX_64_OBJS           := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).LINUX.64.o)

WIN_32_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.32.o)
WIN_64_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.64.o)

ifeq ($(SYSTEM_LZMA_SDK),0)
OBJS_LZMA               := Alloc Lzma2Dec LzmaDec

NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.STATIC.o)
NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.SHARED.o)

LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.32.o)
LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.64.o)

WIN_32_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.32.o)
WIN_64_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.64.o)
endif

##
## Targets: Native Compilation
##

default: $(HASHCAT_FRONTEND)

clean:
	$(RM) -f $(HASHCAT_FRONTEND)
	$(RM) -f $(HASHCAT_LIBRARY)
	$(RM) -f obj/*.o
	$(RM) -f *.bin *.exe
	$(RM) -f *.pid
	$(RM) -f *.restore
	$(RM) -f *.log
	$(RM) -f core
	$(RM) -rf *.induct
	$(RM) -rf *.outfiles
	$(RM) -rf *.dSYM
	$(RM) -rf kernels

distclean: clean
	$(RM) -f *.restore *.pot *.out *.log

##
## Targets: Cross Compilation (for binary release version)
##

binaries: linux32 linux64 win32 win64

linux32: hashcat32.bin
linux64: hashcat64.bin

win32: hashcat32.exe
win64: hashcat64.exe

##
## Targets: Linux install
##

# allow (whitelist) "make install" only on unix-based systems (also disallow cygwin/msys)

ifneq ($(findstring install,$(MAKECMDGOALS)),)
  ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin))
    define ERROR_INSTALL_DISALLOWED
! The 'install' target is not allowed on this operating system ($(UNAME)). \
Only Linux, FreeBSD and Darwin can use the 'install' target
    endef

    $(error $(ERROR_INSTALL_DISALLOWED))
  endif
endif

ifeq ($(SHARED),1)
install: install_docs install_shared install_library install_library_dev install_hashcat
else
install: install_docs install_shared                                     install_hashcat
endif

=== debian/changelog ===
hashcat (4.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.2.1
  * Update debian/copyright
  * Bump Standards-Version (no change)

 -- Sophie Brun <sophie@freexian.com>  Wed, 22 Aug 2018 15:55:19 +0200

hashcat (4.1.0-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * New upstream version 4.1.0
  * Refresh patches

  [ Raphaël Hertzog ]
  * Update team maintainer address to Debian Security Tools
    <team+pkg-security@tracker.debian.org>

 -- Sophie Brun <sophie@freexian.com>  Wed, 04 Apr 2018 15:08:31 +0200

=== debian/control ===
Source: hashcat
Section: net
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Daniel Echeverry <epsilon77@gmail.com>
Build-Depends: debhelper (>=10),
               libgmp-dev,
               opencl-headers
Standards-Version: 4.2.0
Homepage: https://hashcat.net/hashcat/
Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat

Package: hashcat
Architecture: kfreebsd-any amd64 i386
Depends: hashcat-data (>= ${source:Version}),
         pocl-opencl-icd | opencl-icd,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: beignet-opencl-icd, nvidia-opencl-icd, mesa-opencl-icd
Description: World's fastest and most advanced password recovery utility
 Hashcat supports five unique modes of attack for over 200 highly-optimized
 hashing algorithms. hashcat currently supports CPUs, GPUs, and other
 hardware accelerators on Linux, and has facilities to help enable
 distributed password cracking.
 .
 Examples of hashcat supported hashing algorithms are:
 MD5, HMAC-MD5, SHA1, HMAC-SHA1, MySQL323, MySQL4.1/MySQL5, phpass,
 MD5(Wordpress), MD5(phpBB3), MD5(Joomla), md5crypt, MD5(Unix),
 FreeBSD MD5, Cisco-IOS, MD4, NTLM, Domain Cached Credentials (DCC),
 MS Cache, SHA256, HMAC-SHA256, md5apr1, MD5(APR), Apache MD5, SHA512,
 HMAC-SHA512, Cisco-PIX, Cisco-ASA, WPA/WPA2, Double MD5, bcrypt,
 Blowfish(OpenBSD), MD5(Sun), Double SHA1, SHA-3(Keccak),Half MD5,
 Password Safe SHA-256, IKE-PSK MD5, IKE-PSK SHA1,
 NetNTLMv1-VANILLA/NetNTLMv1-ESS, NetNTLMv2, Cisco-IOS SHA256,
 Android PIN, AIX {smd5}, AIX {ssha256}, AIX {ssha512}, AIX {ssha1},
 GOST, GOST R 34, Fortigate (FortiOS), OS X v10.8+, GRUB 2, IPMI2, RAKP,
 HMAC-SHA1, sha256crypt, SHA256(Unix), Drupal7, WBB3, scrypt, Cisco $8$,
 Cisco $9$, Radmin2, Django (PBKDF2-SHA256), Cram MD5, SAP, iSSHA-1,
 PrestaShop, PostgreSQL, Challenge-Response Authentication (MD5),
 MySQL Challenge-Response, Authentication (SHA1),
 SIP digest authentication (MD5), Plaintext, Joomla < 2.5.18, PostgreSQL,
 osCommerce, xt:Commerce, Skype, nsldap, Netscape, LDAP, nsldaps,
 SSHA-1(Base64), Oracle S: Type (Oracle 11+), SMF > v1.1, OS X v10.4,
 v10.5, v10.6, EPi, Django (SHA-1), MSSQL(2000), MSSQL(2005),
 PeopleSoft, EPiServer 6.x < v4, hMailServer, SSHA-512(Base64),
 LDAP {SSHA512}, OS X v10.7, MSSQL(2012 & 2014), vBulletin < v3.8.5,
 PHPS, vBulletin > v3.8.5, IPB2+, MyBB1.2+, Mediawiki B type,
 WebEdition CMS, Redmine.
 .
 Hashcat offers multiple attack modes for obtaining effective and
 complex coverage over a hash's keyspace. These modes are:
 .
  * Brute-Force attack
  * Combinator attack
  * Dictionary attack
  * Fingerprint attack
  * Hybrid attack
  * Mask attack
  * Permutation attack
  * Rule-based attack
  * Table-Lookup attack
  * Toggle-Case attack
  * PRINCE attack

Package: hashcat-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: hashcat
Replaces: hashcat (<= 2.00-0kali3)
Description: Data files for hashcat advanced password recovery utility
 Hashcat is an advanced CPU/GPU-based password recovery utility supporting
 seven unique modes of attack for over 100 optimized hashing algorithms.
 .
 This package contains the data files for hashcat, including charsets,
 rules, salts, and tables.

## hashcat 5.0.0

=== src/Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 SHARED                  := 0
 DEBUG                   := 0
 PRODUCTION              := 1
-PRODUCTION_VERSION      := v4.2.1
+PRODUCTION_VERSION      := v5.0.0
+ENABLE_BRAIN            := 1
 
 ##
 ## Detect Operating System
@@ -118,7 +119,7 @@
 ## You have your own headers somewhere, for example: apt-get install opencl-headers
 ##
 
-OPENCL_HEADERS_KHRONOS  := deps/OpenCL-Headers
+OPENCL_HEADERS_KHRONOS  := deps/git/OpenCL-Headers
 
 ##
 ## Cross compiler paths
@@ -151,43 +152,13 @@
 ## General compiler and linker options
 ##
 
-CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
+LFLAGS                  := $(LDFLAGS)
 
 ifeq ($(PRODUCTION),0)
 CFLAGS                  += -W
 CFLAGS                  += -Wall
 CFLAGS                  += -Wextra
-CFLAGS                  += -Wfloat-equal
-CFLAGS                  += -Wundef
-CFLAGS                  += -Wshadow
-CFLAGS                  += -Wmissing-declarations
-CFLAGS                  += -Wmissing-prototypes
-CFLAGS                  += -Wpointer-arith
-CFLAGS                  += -Wstrict-prototypes
-CFLAGS                  += -Waggregate-return
-CFLAGS                  += -Wswitch-enum
-CFLAGS                  += -Winit-self
-CFLAGS                  += -Werror-implicit-function-declaration
-CFLAGS                  += -Wformat
-CFLAGS                  += -ftrapv
-CFLAGS                  += -Wwrite-strings
-endif
-
-# default Linux and freebsd thread stack size is 2MB
-# default Windows thread stack size is 1MB
-# default macOS thread stack size is 512kB
-# unfortunately, this option isn't supported by older GCC and clang versions
-
-#CFLAGS                  += -Wstack-usage=524288
-
-ifeq ($(SYSTEM_LZMA_SDK),0)
-CFLAGS                  += -Ideps/lzma_sdk/
-else
-CFLAGS                  += $(LZMA_SDK_INCLUDE)
-LDFLAGS                 += -llzmasdk
-endif
-
-LFLAGS                  := $(LDFLAGS)
+endif
 
 ifeq ($(DEBUG),0)
 CFLAGS                  += -O2
@@ -203,6 +174,22 @@
 CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
 endif
 endif
+endif
+
+CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
+
+# LZMA
+ifeq ($(SYSTEM_LZMA_SDK),0)
+CFLAGS                  += -Ideps/lzma_sdk
+else
+CFLAGS                  += $(LZMA_SDK_INCLUDE)
+LDFLAGS                 += -llzmasdk
+endif
+
+# brain and xxHash
+ifeq ($(ENABLE_BRAIN),1)
+CFLAGS                  += -DWITH_BRAIN
+CFLAGS                  += -Ideps/git/xxHash
 endif
 
 ##
@@ -262,6 +249,7 @@
 LFLAGS_NATIVE           += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_NATIVE           += -lpsapi
 LFLAGS_NATIVE           += -liconv
+LFLAGS_NATIVE           += -lws2_32
 endif # MSYS2
 
 ##
@@ -299,23 +287,21 @@
 LFLAGS_CROSS_WIN32      := $(LFLAGS)
 LFLAGS_CROSS_WIN32      += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_CROSS_WIN32      += -lpsapi
+LFLAGS_CROSS_WIN32      += -lws2_32
 LFLAGS_CROSS_WIN64      := $(LFLAGS)
 LFLAGS_CROSS_WIN64      += -Wl,--dynamicbase -Wl,--nxcompat
 LFLAGS_CROSS_WIN64      += -lpsapi
-
-CFLAGS_REMOVE_LZMA        := -Wmissing-declarations -Wmissing-prototypes -Wstrict-prototypes -Wundef
-
-CFLAGS_NATIVE_LZMA        := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_NATIVE))
-CFLAGS_CROSS_LINUX32_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX32))
-CFLAGS_CROSS_LINUX64_LZMA := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_LINUX64))
-CFLAGS_CROSS_WIN32_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN32))
-CFLAGS_CROSS_WIN64_LZMA   := $(filter-out $(CFLAGS_REMOVE_LZMA),$(CFLAGS_CROSS_WIN64))
+LFLAGS_CROSS_WIN64      += -lws2_32
 
 ##
 ## Objects
 ##
 
-OBJS_ALL                := affinity autotune benchmark bitmap bitops combinator common convert cpt cpu_aes cpu_crc32 cpu_des cpu_md4 cpu_md5 cpu_sha1 cpu_sha256 debugfile dictstat dispatch dynloader event ext_ADL ext_nvapi ext_nvml ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface locking logfile loopback memory monitor mpsp opencl outfile_check outfile pidfile potfile restore rp rp_cpu rp_kernel_on_cpu rp_kernel_on_cpu_optimized selftest shared status stdout straight terminal thread timer tuningdb usage user_options wordlist
+OBJS_ALL                := affinity autotune benchmark bitmap bitops combinator common convert cpt cpu_aes cpu_crc32 cpu_des cpu_md4 cpu_md5 cpu_sha1 cpu_sha256 debugfile dictstat dispatch dynloader event ext_ADL ext_nvapi ext_nvml ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface locking logfile loopback memory monitor mpsp opencl outfile_check outfile pidfile potfile restore rp rp_cpu rp_kernel_on_cpu rp_kernel_on_cpu_optimized selftest slow_candidates shared status stdout straight terminal thread timer tuningdb usage user_options wordlist
+
+ifeq ($(ENABLE_BRAIN),1)
+OBJS_ALL                += brain
+endif
 
 NATIVE_STATIC_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.STATIC.o)
 NATIVE_SHARED_OBJS      := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.SHARED.o)
@@ -325,6 +311,19 @@
 
 WIN_32_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.64.o)
+
+ifeq ($(ENABLE_BRAIN),1)
+OBJS_XXHASH             := xxhash
+
+NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).NATIVE.STATIC.o)
+NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).NATIVE.SHARED.o)
+
+LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).LINUX.32.o)
+LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).LINUX.64.o)
+
+WIN_32_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.32.o)
+WIN_64_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.64.o)
+endif
 
 ifeq ($(SYSTEM_LZMA_SDK),0)
 OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
@@ -397,3 +396,13 @@
 install: install_docs install_shared                                     install_hashcat
 endif
 
+# we need this extra target to make sure that for parallel builds (i.e. 2+ Makefile targets could possible run at the same time)
+# the root folder of the shared directory is created first (and is a dependency for the targets that depend on it)
+
+install_make_library_dev_root:
+	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(LIBRARY_DEV_ROOT_FOLDER)
+
+install_make_shared_root:
+	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(SHARED_ROOT_FOLDER)
+
+install_docs: install_make_shared_root

=== debian/changelog ===
hashcat (5.0.0-1) unstable; urgency=medium

  [ Sophie Brun ]
  * Team upload.
  * New upstream version 5.0.0
  * Refresh patches
  * Add libxxhash-dev to build-dep
  * Bump Standards-Version to 4.2.1 (no change)
  * Add a patch to use the packaged libxxhash

  [ Raphaël Hertzog ]
  * Switch to debhelper compat level 11

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 08 Nov 2018 14:27:50 +0100

## hashcat 5.1.0+ds1

=== src/Makefile ===
--- 
+++ 
@@ -6,8 +6,11 @@
 SHARED                  := 0
 DEBUG                   := 0
 PRODUCTION              := 1
-PRODUCTION_VERSION      := v5.0.0
+PRODUCTION_VERSION      := v5.1.0
 ENABLE_BRAIN            := 1
+USE_SYSTEM_LZMA         := 0
+USE_SYSTEM_OPENCL       := 0
+USE_SYSTEM_XXHASH       := 0
 
 ##
 ## Detect Operating System
@@ -78,7 +81,7 @@
 VERSION_PURE            := $(shell echo "$(VERSION_TAG)" | $(SED) 's/.*v\([\.0-9]*\).*/\1/')
 
 ##
-## Installation paths (Linux only)
+## Installation paths
 ##
 
 DESTDIR                 ?=
@@ -93,6 +96,36 @@
 LIBRARY_DEV_FOLDER      ?= $(LIBRARY_DEV_ROOT_FOLDER)/hashcat
 
 ##
+## Depencies paths
+##
+
+ifeq ($(USE_SYSTEM_LZMA),0)
+DEPS_LZMA_PATH          := deps/LZMA-SDK/C
+else
+DEPS_LZMA_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+ifeq ($(USE_SYSTEM_OPENCL),0)
+DEPS_OPENCL_PATH        := deps/OpenCL-Headers
+else
+DEPS_OPENCL_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+ifeq ($(USE_SYSTEM_XXHASH),0)
+DEPS_XXHASH_PATH        := deps/xxHash
+else
+DEPS_XXHASH_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)/
+endif
+
+## To compile win-iconv with mingw clone from here: https://github.com/win-iconv/win-iconv
+##
+## Then patch the makefile with the patches from tools/win-iconv-*.diff and run make install
+##
+
+WIN_ICONV_32            := /opt/win-iconv-32
+WIN_ICONV_64            := /opt/win-iconv-64
+
+##
 ## Filenames for library and frontend
 ##
 
@@ -114,14 +147,6 @@
 endif # MSYS2
 
 ##
-## Dependencies
-## You may ignore them if you're compiling only a native binary and
-## You have your own headers somewhere, for example: apt-get install opencl-headers
-##
-
-OPENCL_HEADERS_KHRONOS  := deps/git/OpenCL-Headers
-
-##
 ## Cross compiler paths
 ##
 
@@ -131,22 +156,11 @@
 CC_WIN_32               := i686-w64-mingw32-gcc
 CC_WIN_64               := x86_64-w64-mingw32-gcc
 
-## To compile win-iconv with mingw clone from here: https://github.com/win-iconv/win-iconv
-##
-## Then patch the makefile with the patches from tools/win-iconv-*.diff and run make install
-##
-
-WIN_ICONV_32            := /opt/win-iconv-32
-WIN_ICONV_64            := /opt/win-iconv-64
-
 ##
 ## Misc stuff
 ##
 
 COMPTIME                := $(shell date +%s)
-SYSTEM_LZMA_SDK         := 0
-
-LZMA_SDK_INCLUDE        := $(LIBRARY_DEV_ROOT_FOLDER)/lzma-sdk/C
 
 ##
 ## General compiler and linker options
@@ -179,17 +193,21 @@
 CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/
 
 # LZMA
-ifeq ($(SYSTEM_LZMA_SDK),0)
-CFLAGS                  += -Ideps/lzma_sdk
-else
-CFLAGS                  += $(LZMA_SDK_INCLUDE)
-LDFLAGS                 += -llzmasdk
-endif
+CFLAGS                  += -I$(DEPS_LZMA_PATH)
+ifeq ($(USE_SYSTEM_LZMA),1)
+LFLAGS                  += -llzmasdk
+endif
+
+# OpenCL
+CFLAGS                  += -I$(DEPS_OPENCL_PATH)
 
 # brain and xxHash
 ifeq ($(ENABLE_BRAIN),1)
 CFLAGS                  += -DWITH_BRAIN
-CFLAGS                  += -Ideps/git/xxHash
+CFLAGS                  += -I$(DEPS_XXHASH_PATH)
+ifeq ($(USE_SYSTEM_XXHASH),1)
+LFLAGS                  += -lxxhash
+endif
 endif
 
 ##
@@ -312,6 +330,20 @@
 WIN_32_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.64.o)
 
+ifeq ($(USE_SYSTEM_LZMA),0)
+OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
+
+NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.STATIC.o)
+NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.SHARED.o)
+
+LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.32.o)
+LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.64.o)
+
+WIN_32_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.32.o)
+WIN_64_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.64.o)
+endif
+
+ifeq ($(USE_SYSTEM_XXHASH),0)
 ifeq ($(ENABLE_BRAIN),1)
 OBJS_XXHASH             := xxhash
 
@@ -324,18 +356,6 @@
 WIN_32_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.32.o)
 WIN_64_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.64.o)
 endif
-
-ifeq ($(SYSTEM_LZMA_SDK),0)
-OBJS_LZMA               := Alloc Lzma2Dec LzmaDec
-
-NATIVE_STATIC_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.STATIC.o)
-NATIVE_SHARED_OBJS      += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.SHARED.o)
-
-LINUX_32_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.32.o)
-LINUX_64_OBJS           += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.64.o)
-
-WIN_32_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.32.o)
-WIN_64_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.64.o)
 endif
 
 ##
@@ -399,10 +419,3 @@
 # we need this extra target to make sure that for parallel builds (i.e. 2+ Makefile targets could possible run at the same time)
 # the root folder of the shared directory is created first (and is a dependency for the targets that depend on it)
 
-install_make_library_dev_root:
-	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(LIBRARY_DEV_ROOT_FOLDER)
-
-install_make_shared_root:
-	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(SHARED_ROOT_FOLDER)
-
-install_docs: install_make_shared_root

=== debian/changelog ===
hashcat (5.1.0+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 5.1.0
  * Exclude from tarball deps/OpenCL* and deps/xxhash
  * Refresh patches and remove use-system-libxxhash.patch
  * d/rules: Use system libraries

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 07 Dec 2018 10:44:05 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
-Build-Depends: debhelper (>=10),
+Build-Depends: debhelper (>= 11),
                libgmp-dev,
+               libxxhash-dev,
                opencl-headers
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr DEBUG=1 COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1

override_dh_auto_install:
	dh_auto_install -- USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1

override_dh_installchangelogs:
	dh_installchangelogs docs/changes.txt

override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example0.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example400.sh
	chmod 644 debian/hashcat-data/usr/share/doc/hashcat-data/examples/example500.sh

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hashcat-$1.tar.gz%,uversionmangle=s/^3.(5|6).0/3.${1}0/,dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/hashcat/hashcat/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## hashcat 6.1.1+ds1

=== src/Makefile ===
##
## Author......: See docs/credits.txt
## License.....: MIT
##

SHARED                  ?= 0
DEBUG                   := 0
PRODUCTION              := 1
PRODUCTION_VERSION      := v6.1.1
ENABLE_CUBIN            ?= 1
ENABLE_BRAIN            ?= 1
USE_SYSTEM_LZMA         ?= 0
USE_SYSTEM_ZLIB         ?= 0
USE_SYSTEM_OPENCL       ?= 0
USE_SYSTEM_XXHASH       ?= 0

##
## Detect Operating System
##

UNAME                   := $(shell uname -s)

# we need to strip the windows version number to be able to build hashcat on cygwin hosts
UNAME                   := $(patsubst CYGWIN_NT-%,CYGWIN,$(UNAME))

# same for msys
UNAME                   := $(patsubst MSYS_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW32_NT-%,MSYS2,$(UNAME))
UNAME                   := $(patsubst MINGW64_NT-%,MSYS2,$(UNAME))

ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin CYGWIN MSYS2))
$(error "! Your Operating System ($(UNAME)) is not supported by this Makefile")
endif

ifeq ($(DEBUG),1)
$(warning "## Detected Operating System : $(UNAME)")
endif

##
## Makefile flags
##

MAKEFLAGS               += -l -j 8 -rR --no-print-directory

ifneq ($(findstring clean,$(MAKECMDGOALS)),)
MAKEFLAGS               += -j 1
endif

##
## Do not modify
##

MODULE_INTERFACE_VERSION := 520

##
## Native compiler paths
##

CC                      := gcc
AR                      := ar
FIND                    := find
INSTALL                 := install
RM                      := rm
SED                     := sed
SED_IN_PLACE            := -i

ifeq ($(UNAME),Darwin)
CC                      := clang
# the sed -i option of macOS requires a parameter for the backup file (we just use "")
AR                      := /usr/bin/ar
SED                     := /usr/bin/sed
SED_IN_PLACE            := -i ""
PROD_VERS               := $(shell sw_vers -productVersion | cut -d. -f2)
endif

ifeq ($(UNAME),FreeBSD)
CC                      := cc
SED                     := gsed
endif

##
## Version
##

ifeq ($(PRODUCTION),1)
VERSION_TAG             := $(PRODUCTION_VERSION)
else
VERSION_TAG             := $(shell git describe --tags --dirty=+ || echo $(PRODUCTION_VERSION))
endif # PRODUCTION

VERSION_PURE            := $(shell echo "$(VERSION_TAG)" | $(SED) 's/.*v\([\.0-9]*\).*/\1/')

##
## Installation paths
##

DESTDIR                 ?=
PREFIX                  ?= /usr/local

INSTALL_FOLDER          ?= $(PREFIX)/bin
SHARED_ROOT_FOLDER      ?= $(PREFIX)/share
SHARED_FOLDER           ?= $(SHARED_ROOT_FOLDER)/hashcat
DOCUMENT_FOLDER         ?= $(SHARED_ROOT_FOLDER)/doc/hashcat
LIBRARY_FOLDER          ?= $(PREFIX)/lib
LIBRARY_DEV_ROOT_FOLDER ?= $(PREFIX)/include
LIBRARY_DEV_FOLDER      ?= $(LIBRARY_DEV_ROOT_FOLDER)/hashcat

##
## Depencies paths
##

ifeq ($(USE_SYSTEM_LZMA),0)
DEPS_LZMA_PATH          := deps/LZMA-SDK/C
else
DEPS_LZMA_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_ZLIB),0)
DEPS_ZLIB_PATH          := deps/zlib
else
DEPS_ZLIB_PATH          := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_OPENCL),0)
DEPS_OPENCL_PATH        := deps/OpenCL-Headers
else
DEPS_OPENCL_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)
endif

ifeq ($(USE_SYSTEM_XXHASH),0)
DEPS_XXHASH_PATH        := deps/xxHash
else
DEPS_XXHASH_PATH        := $(LIBRARY_DEV_ROOT_FOLDER)
endif

##
## Filenames for library and frontend
##

HASHCAT_FRONTEND        := hashcat
HASHCAT_LIBRARY         := libhashcat.so.$(VERSION_PURE)

ifeq ($(UNAME),Darwin)
HASHCAT_LIBRARY         := libhashcat.$(VERSION_PURE).dylib
endif # Darwin

ifeq ($(UNAME),CYGWIN)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
HASHCAT_FRONTEND        := hashcat.exe
HASHCAT_LIBRARY         := hashcat.dll
endif # MSYS2

##
## Misc stuff
##

COMPTIME                := $(shell date +%s)

##
## General compiler and linker options
##

LFLAGS                  := $(LDFLAGS)

ifeq ($(PRODUCTION),0)
CFLAGS                  += -W
CFLAGS                  += -Wall
CFLAGS                  += -Wextra
endif

## because LZMA SDK
ifeq ($(CC),clang)
CFLAGS                  += -Wno-enum-conversion
endif

## because ZLIB
ifeq ($(USE_SYSTEM_ZLIB),0)
CFLAGS_ZLIB             += -Wno-implicit-fallthrough
CFLAGS_ZLIB             += -Wno-implicit-function-declaration
CFLAGS_ZLIB             += -Wno-unused-parameter
CFLAGS_ZLIB             += -DIOAPI_NO_64
endif

ifeq ($(DEBUG),0)
CFLAGS                  += -O2
ifneq ($(UNAME),Darwin)
LFLAGS                  += -s
endif
else
ifeq ($(DEBUG),1)
ifneq ($(UNAME),Darwin)
CFLAGS                  += -DDEBUG -Og -ggdb
else
CFLAGS                  += -DDEBUG -O0 -ggdb
endif
else
ifeq ($(DEBUG),2)
ifneq ($(UNAME),Darwin)
CFLAGS                  += -DDEBUG -Og -ggdb
else
CFLAGS                  += -DDEBUG -O0 -ggdb
endif
CFLAGS                  += -fsanitize=address -fno-omit-frame-pointer
endif
endif
endif

CFLAGS                  += -pipe -std=gnu99 -Iinclude/ -IOpenCL/

# LZMA
CFLAGS                  += -I$(DEPS_LZMA_PATH)
ifeq ($(USE_SYSTEM_LZMA),1)
LFLAGS                  += -llzmasdk
endif

# ZLIB
CFLAGS                  += -I$(DEPS_ZLIB_PATH) -I$(DEPS_ZLIB_PATH)/contrib
ifeq ($(USE_SYSTEM_ZLIB),1)
LFLAGS                  += -lz -lminizip
endif

# OpenCL
CFLAGS                  += -I$(DEPS_OPENCL_PATH)

# brain and xxHash
ifeq ($(ENABLE_BRAIN),1)
CFLAGS                  += -DWITH_BRAIN
CFLAGS                  += -I$(DEPS_XXHASH_PATH)
ifeq ($(USE_SYSTEM_XXHASH),1)
LFLAGS                  += -lxxhash
endif
endif

# CUDA binary cache
ifeq ($(ENABLE_CUBIN),1)
CFLAGS                  += -DWITH_CUBIN
endif

##
## Native compilation target
##

ifeq ($(UNAME),Linux)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -ldl
LFLAGS_NATIVE           += -lrt
LFLAGS_NATIVE           += -lm
endif # Linux

ifeq ($(UNAME),FreeBSD)
ifndef PORTNAME
CFLAGS_NATIVE           := $(CFLAGS)
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -lm
LFLAGS_NATIVE           += -liconv
endif
endif # FreeBSD

ifeq ($(UNAME),Darwin)
export MACOSX_DEPLOYMENT_TARGET=10.9
CFLAGS_NATIVE           := $(CFLAGS)

ifeq ($(shell test $(PROD_VERS) -le 11; echo $$?), 0)
CFLAGS_NATIVE           += -DMISSING_CLOCK_GETTIME
endif

LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -framework OpenCL
LFLAGS_NATIVE           += -lpthread
LFLAGS_NATIVE           += -liconv
endif # Darwin

ifeq ($(UNAME),CYGWIN)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase
LFLAGS_NATIVE           += -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
endif # CYGWIN

ifeq ($(UNAME),MSYS2)
CFLAGS_NATIVE           := $(CFLAGS)
CFLAGS_NATIVE           += -DWITH_HWMON
LFLAGS_NATIVE           := $(LFLAGS)
LFLAGS_NATIVE           += -Wl,--dynamicbase
LFLAGS_NATIVE           += -Wl,--nxcompat
LFLAGS_NATIVE           += -lpsapi
LFLAGS_NATIVE           += -liconv
LFLAGS_NATIVE           += -lws2_32
endif # MSYS2

##
## Objects
##

EMU_OBJS_ALL            := emu_general emu_inc_common emu_inc_platform emu_inc_scalar emu_inc_simd
EMU_OBJS_ALL            += emu_inc_rp emu_inc_rp_optimized
EMU_OBJS_ALL            += emu_inc_truecrypt_crc32 emu_inc_truecrypt_keyfile emu_inc_truecrypt_xts emu_inc_veracrypt_xts
EMU_OBJS_ALL            += emu_inc_hash_md4 emu_inc_hash_md5 emu_inc_hash_ripemd160 emu_inc_hash_sha1 emu_inc_hash_sha256 emu_inc_hash_sha384 emu_inc_hash_sha512 emu_inc_hash_streebog256 emu_inc_hash_streebog512 emu_inc_ecc_secp256k1
EMU_OBJS_ALL            += emu_inc_cipher_aes emu_inc_cipher_camellia emu_inc_cipher_des emu_inc_cipher_kuznyechik emu_inc_cipher_serpent emu_inc_cipher_twofish

OBJS_ALL                := affinity autotune backend benchmark bitmap bitops combinator common convert cpt cpu_crc32 debugfile dictstat dispatch dynloader event ext_ADL ext_cuda ext_nvapi ext_nvml ext_nvrtc ext_OpenCL ext_sysfs ext_lzma filehandling folder hashcat hashes hlfmt hwmon induct interface keyboard_layout locking logfile loopback memory monitor mpsp outfile_check outfile pidfile potfile restore rp rp_cpu selftest slow_candidates shared status stdout straight terminal thread timer tuningdb usage user_options wordlist $(EMU_OBJS_ALL)

ifeq ($(ENABLE_BRAIN),1)
OBJS_ALL                += brain
endif

NATIVE_OBJS             := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).NATIVE.o)
LINUX_OBJS              := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).LINUX.o)
WIN_OBJS                := $(foreach OBJ,$(OBJS_ALL),obj/$(OBJ).WIN.o)

ifeq ($(USE_SYSTEM_LZMA),0)
OBJS_LZMA               := Alloc Lzma2Dec LzmaDec

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_LZMA),obj/$(OBJ).WIN.o)
endif

ifeq ($(USE_SYSTEM_ZLIB),0)
OBJS_ZLIB               := adler32 crc32 deflate inflate inffast inftrees trees gzread gzwrite gzclose zutil gzlib contrib/minizip/unzip contrib/minizip/ioapi

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_ZLIB),obj/$(OBJ).WIN.o)
endif

ifeq ($(USE_SYSTEM_XXHASH),0)
ifeq ($(ENABLE_BRAIN),1)
OBJS_XXHASH             := xxhash

NATIVE_OBJS             += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).NATIVE.o)
LINUX_OBJS              += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).LINUX.o)
WIN_OBJS                += $(foreach OBJ,$(OBJS_XXHASH),obj/$(OBJ).WIN.o)
endif
endif

##
## Targets: Native Compilation
##

default: $(HASHCAT_FRONTEND) modules

clean:
	$(RM) -f $(HASHCAT_FRONTEND)
	$(RM) -f $(HASHCAT_LIBRARY)
	$(RM) -rf modules/*.dSYM
	$(RM) -f modules/*.dll
	$(RM) -f modules/*.so
	$(RM) -f obj/*/*/*.o
	$(RM) -f obj/*.o
	$(RM) -f obj/*.a
	$(RM) -rf *.dSYM
	$(RM) -f *.dylib
	$(RM) -f *.bin *.exe
	$(RM) -f *.pid
	$(RM) -f *.log
	$(RM) -f core
	$(RM) -rf *.induct
	$(RM) -rf *.outfiles
	$(RM) -rf kernels

distclean: clean
	$(RM) -f *.restore
	$(RM) -f *.potfile
	$(RM) -f *.out
	$(RM) -f hashcat.dictstat2
	$(RM) -f brain.*
	$(RM) -rf test_[0-9]*
	$(RM) -rf tools/luks_tests

##
## Targets: Linux install
##

# allow (whitelist) "make install" only on unix-based systems (also disallow cygwin/msys)

ifneq ($(findstring install,$(MAKECMDGOALS)),)
  ifeq (,$(filter $(UNAME),Linux FreeBSD Darwin))
    define ERROR_INSTALL_DISALLOWED
! The 'install' target is not allowed on this operating system ($(UNAME)). \
Only Linux, FreeBSD and Darwin can use the 'install' target
    endef

    $(error $(ERROR_INSTALL_DISALLOWED))
  endif
endif

ifeq ($(SHARED),1)
install: install_docs install_shared install_library install_library_dev install_kernels install_modules install_hashcat
else
install: install_docs install_shared                                     install_kernels install_modules install_hashcat
endif

# we need this extra target to make sure that for parallel builds (i.e. 2+ Makefile targets could possible run at the same time)
# the root folder of the shared directory is created first (and is a dependency for the targets that depend on it)

install_make_library_dev_root:
	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(LIBRARY_DEV_ROOT_FOLDER)

install_make_shared_root:
	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(SHARED_ROOT_FOLDER)

install_docs: install_make_shared_root
	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(DOCUMENT_FOLDER)
	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(DOCUMENT_FOLDER)/charsets
	$(INSTALL) -m 755 -d                                                    $(DESTDIR)$(DOCUMENT_FOLDER)/docs

=== debian/changelog ===
hashcat (6.1.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 6.1.1+ds1

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 31 Jul 2020 15:09:49 +0200

hashcat (6.0.0+ds1-1) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * Add dep/zlib in Files-Excluded (already in Debian)
  * New upstream version 6.0.0+ds1
  * Update description package
  * Update dates in debian/copyright
  * Update URL to https in debian/copyright
  * Refresh patches
  * Use Debian package zlib1g-dev for the build
    - add zlib1g-dev in build-dep
    - debian/rules: USE_SYSTEM_ZLIB=1
  * Use debian package libminizip-dev
    - add libminizip-dev in build-dep
    - debian/rules: export DEB_LDFLAGS_MAINT_APPEND = -lminizip
    - add a patch to change path to minizip/ioapi.h
  * Use upstream installation except for modules/*.so
    - Use upstream install: no more files listed by dh_missing
    - Don't install the modules/.*so in /usr/share/hashcat but in
      /usr/lib/hashcat and add a symlink (see
      https://github.com/hashcat/hashcat/issues/2462)

  [ Raphaël Hertzog ]
  * Stop using DEBUG=1 but patch makefile to ensure we don't strip binaries
    anyway

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 19 Jun 2020 12:20:24 +0200

hashcat (5.1.0+ds1-2) unstable; urgency=medium

  * Team upload.

  [ Samuel Henrique ]
  * Add salsa-ci.yml
  * Fix my name in changelog
  * Configure git-buildpackage

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Sophie Brun ]
  * Add arm64 and armhf in supported arch (see
    https://bugs.kali.org/view.php?id=6010)
  * Update manpage (Closes: #922811)
  * Bump Standards-Version to 4.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 20 Feb 2020 15:10:37 +0100

=== debian/control ===
--- 
+++ 
@@ -3,24 +3,26 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Daniel Echeverry <epsilon77@gmail.com>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                libgmp-dev,
+	       libminizip-dev,
                libxxhash-dev,
+	       zlib1g-dev,
                opencl-headers
-Standards-Version: 4.2.1
+Standards-Version: 4.5.0
 Homepage: https://hashcat.net/hashcat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashcat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashcat
 
 Package: hashcat
-Architecture: kfreebsd-any amd64 i386
+Architecture: kfreebsd-any amd64 i386 armhf arm64
 Depends: hashcat-data (>= ${source:Version}),
          pocl-opencl-icd | opencl-icd,
          ${misc:Depends},
          ${shlibs:Depends}
 Suggests: beignet-opencl-icd, nvidia-opencl-icd, mesa-opencl-icd
 Description: World's fastest and most advanced password recovery utility
- Hashcat supports five unique modes of attack for over 200 highly-optimized
+ Hashcat supports five unique modes of attack for over 300 highly-optimized
  hashing algorithms. hashcat currently supports CPUs, GPUs, and other
  hardware accelerators on Linux, and has facilities to help enable
  distributed password cracking.

=== debian/rules ===
--- 
+++ 
@@ -1,15 +1,24 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE = 1
+
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -lminizip
+
+MAKEFILE_VARIABLES = PREFIX=/usr COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1 USE_SYSTEM_ZLIB=1
 
 %:
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- PREFIX=/usr DEBUG=1 COMPTIME=$(SOURCE_DATE_EPOCH) USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1
+	dh_auto_build -- $(MAKEFILE_VARIABLES)
 
 override_dh_auto_install:
-	dh_auto_install -- USE_SYSTEM_XXHASH=1 USE_SYSTEM_OPENCL=1
+	dh_auto_install -- $(MAKEFILE_VARIABLES)
+
+override_dh_install:
+	rm -f debian/tmp/usr/share/doc/hashcat/docs/changes.txt
+	rm -f debian/tmp/usr/share/doc/hashcat/docs/license.txt
+	dh_install
 
 override_dh_installchangelogs:
 	dh_installchangelogs docs/changes.txt
